#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct drvo
{
	char ime[15];
	int uzrast;
	int broj;
	int balans;
	struct drvo *desni, *levi;
}drvo;

int dubina(drvo *p)
{
	int dl,dd;
	dl=dd=0;
	if(p!=NULL)
	{
		if(p->levi!=NULL) dubina(p->levi);
		if(p->desni!=NULL) dubina(p->desni);
		
		if(dd>dl) return ++dd;
		else return ++dl;
		
	}
	else return 0;
	
}

void lrotacija(drvo **p)
{
	drvo *poml, *pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	
}

void drotacija(drvo **p)
{
	drvo *poml, *pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	
	
}


int dodaj(drvo **p, char ime[], int uzrast, int broj)
{
	drvo *pom=*p;
	int ink=0,rez=0;
	
	if(pom==NULL)
	{
		pom=(drvo*)malloc(sizeof(drvo));
		pom->desni=pom->levi=NULL;
		strcpy(pom->ime,ime);
		pom->uzrast=uzrast;
		pom->broj=broj;
		pom->balans=0;
		rez=1;
		
	}
	else
	{
		if(uzrast>pom->uzrast) ink=dodaj(&(pom->desni),ime,uzrast,broj);
		else if (uzrast<pom->uzrast) ink=-dodaj(&(pom->levi),ime,uzrast,broj);
		else
		{
			if(strcmp(ime,pom->ime)==0) ink=dodaj(&(pom->desni),ime,uzrast,broj);
			else if(strcmp(ime,pom->ime)<=-1) ink=-dodaj(&(pom->levi),ime,uzrast,broj);
			else if(strcmp(ime,pom->ime)>=1)  ink=dodaj(&(pom->desni),ime,uzrast,broj);
			
		}
		pom->balans+=ink;
		
		if(ink!=0 && pom->balans!=0)
		{
			if(pom->balans<-1)
			{
				if(pom->levi->balans<0) drotacija(&pom);
				else
				{
					lrotacija(&(pom->levi));
					drotacija(&pom);
				}
			}
			else if(pom->balans>1)
			{
				if(pom->desni->balans>0) lrotacija(&pom);
				else
				{
					drotacija(&(pom->desni));
					lrotacija(&pom);
				}
			}
			else rez=1;
		}
	}
	*p=pom;
	return rez;
}



drvo * Formiraj()
{
	drvo *p=NULL;
	int i,n;
	char ime[15];
	int broj,uzrast;
	printf("Unesite broj dece:\n");
	scanf("%d",&n);
	
	for(i=0;i<n;i++)
	{
		printf("Unesite podatke o %d-om detetu\n",i+1);
		scanf("%s",ime);
		scanf("%d",&uzrast);
		scanf("%d",&broj);
		dodaj(&p,ime,uzrast,broj);
	}
	return p;
}

void Ispis(drvo *p)
{
	if(p!=NULL)
	{
		Ispis(p->desni);
		printf("ime:%s   uzrast:%d   poklono:%d\n",p->ime,p->uzrast,p->broj);
		Ispis(p->levi);
	}
	
}

void Napravi(drvo **q, drvo *p, int godine)
{
	if(p!=NULL)
	{
		if(((p->uzrast+12)/12)<godine) dodaj(q,p->ime,p->uzrast,p->broj);
		Napravi(q,p->levi,godine);
		Napravi(q,p->desni,godine);
	}
}

void Prebroji(drvo *p, int nivo, int pokloni, int *broj, int i)
{
	if(p!=NULL)
	{
		Prebroji(p->levi,nivo,pokloni,broj,++i);
		if(i==nivo && pokloni>=p->broj) (*broj)++;
		Prebroji(p->desni,nivo,pokloni,broj,++i);
		
	}
	
}

int main()
{
	drvo *p=NULL;
	drvo *q=NULL;
	int godine;
	int nivo,i,pokloni;
	i=1;
	int br;
	br=0;
	p=Formiraj();
	Ispis(p);
	printf("Uneti broj godina koji predstavlja minimum koje dete mora da ima naredne godine da bi primilo poklon\n");
	scanf("%d",&godine);
	Napravi(&q,p,godine);
	Ispis(q);
	printf("unesite nivo i broj poklona\n");
	scanf("%d",&nivo);
	scanf("%d",&pokloni);
	Prebroji(p,nivo,pokloni,&br,i);
	printf("%d",br);
	return 0;
	
}
