#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct DedaMraz{
	char IME[20];
	int UZRAST;
	int BROJ_IGRACAKA;
	int balans;
	struct DedaMraz *levi, *desni;
}DEDA;

int dubina(DEDA *p){
	int dd=0, dl=0;
	
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}
DEDA *lrotacija(DEDA *p){
	DEDA *pom;
	
	pom = p->desni->levi;
	p->desni->levi = p;
	p->levi->desni = pom;
	
	p->levi->balans=dubina(p->levi->desni)-dubina(p->levi->levi);
	p->balans=dubina(p->desni)-dubina(p->levi);
	return p;
}

DEDA *drotacija(DEDA *p){
	DEDA *pom;
	
	pom = p->levi->desni;
	p->levi->desni = p;
	p->desni->levi = pom;
	
	p->desni->balans=dubina(p->desni->desni)-dubina(p->desni->levi);
	p->balans=dubina(p->desni)-dubina(p->levi);
	return p;
}

int uslov(DEDA *temp, DEDA *p){
	if(temp->UZRAST > p->UZRAST)
		return 1;
	if((temp->UZRAST == p->UZRAST) && strcmp(temp->IME,p->IME)>=0)
		return 1;
	return 0;
	
}

int dodaj(DEDA **p2, DEDA *temp){
	int ink, rez=0;
	DEDA *p;
	p=(*p2);
	
	if(p==NULL){
		p=temp;
		p->desni=NULL;
		p->levi=NULL;
		p->balans=0;
		rez=1;
	}
	else{
		if(uslov(temp,p))
			ink=dodaj(&(p->desni),temp);
		else
			ink=-dodaj(&(p->levi),temp);
			p->balans+=ink;
		
		if(ink != 0 && p->balans != 0){
			if(p->balans < -1){
				if(p->levi->balans < 0){
					p=drotacija(p);
				}
				else{
					p->levi = lrotacija(p->levi);
					p=drotacija(p);
				}
			}
			else if(p->balans > 1){
					if(p->desni->balans > 0){
						p=lrotacija(p);
					}
					else{
						p->desni=drotacija(p->desni);
						p=lrotacija(p);
					}
				}
				else rez = 1;
		}
	}
	(*p2)=p;
	return rez;
}

void kreiraj(DEDA **p2){

	int n,i;
	DEDA *p, *temp;
	
	p=(*p2);
	
	scanf("%d",&n);
	
	for(i=0;i<n;i++){
		temp = malloc(sizeof(DEDA));
		scanf("%s",temp->IME);
		scanf("%d",&temp->UZRAST);
		scanf("%d",&temp->BROJ_IGRACAKA);
		
		dodaj(&p,temp);
	}
	(*p2)=p;
}

void ispis(DEDA *p){
	if(p != NULL){
		ispis(p->desni);
		printf("%s %d %d %d\n", p->IME,p->UZRAST, p->BROJ_IGRACAKA,p->balans);
		ispis(p->levi);
	}
}

DEDA *brisanje(DEDA *p, DEDA *novo, int provera){
	if(p != NULL){
		novo = brisanje(p->levi,novo,provera);
		novo = brisanje(p->desni,novo,provera);
		
		p->levi = NULL;
		p->desni = NULL;
		
		if(p->UZRAST <= provera*12)
			dodaj(&novo,p);
	}
	return novo;
}

int nivo(DEDA *pocetak, DEDA *p, int k, int m){
	int dd=0,dl=0;
	if(p){
		if(p->levi)
			dl=dubina(p->levi);
		if(p->desni)
			dd=dubina(p->desni);
			
			if((dl==k || dd==k) && (p->BROJ_IGRACAKA == m))
				printf("%s %d %d %d\n", p->IME,p->UZRAST, p->BROJ_IGRACAKA,p->balans);
				
			if(dl>dd) return ++dl;
			else return ++dd;
	}
	else return 0;
}

main()
{
	DEDA *p=NULL;
	int provera,k,m;
	
	kreiraj(&p);
	ispis(p);
	scanf("%d",&provera);
	
	p=brisanje(p,NULL,provera);
	ispis(p);
	scanf("%d",&k);
	scanf("%d",&m);
	
	nivo(p,p,k,m);
}
