#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct STRUKTURA{
	char ime[20];
	int uzrast;
	int broj_igracaka;
	int bal;
	struct STRUKTURA *levi, *desni;
}STRUKTURA;

int Dubina(STRUKTURA *p){
	int dd=0;
	int dl=0;
		if(p){
			if(p->levi) dl=Dubina(p->levi);
			if(p->desni) dd=Dubina(p->desni);
			if(dl>dd) return ++dl;
			else return dd;
		}
		else return 0;
}

STRUKTURA *lrotacija(STRUKTURA *p){
	STRUKTURA *pom;
	pom=p->desni->levi;
	p->desni->levi=p;
	p=p->desni;
	p->levi->desni=pom;
	
	p->levi->bal=Dubina(p->levi->desni)-Dubina(p->levi->levi);
	p->bal=Dubina(p->desni)-Dubina(p->levi);
	return p;
}

STRUKTURA *drotacija(STRUKTURA *p){
	STRUKTURA *pom;
	pom=p->levi->desni;
	p->levi->desni=p;
	p=p->levi;
	p->desni->levi=pom;
	
	p->desni->bal=Dubina(p->desni->desni)-Dubina(p->desni->levi);
	p->bal=Dubina(p->desni)-Dubina(p->levi);
	return p;
}

int uslov(STRUKTURA *temp, STRUKTURA *p){
	if(temp->uzrast>=p->uzrast)
	return 1;
	if(temp->uzrast==p->uzrast && strcmp(temp->ime, p->ime)>=0) return 1;
	return 0;
}

int Dodaj(STRUKTURA **p2, STRUKTURA *temp){
	int ink, rezultat;
	STRUKTURA *p;
	
	p=(*p2);
	rezultat=0;
	
	if(p==NULL){
		p=temp;
		p->desni=NULL;
		p->levi=NULL;
		p->bal=0;
		rezultat=1;
	}
	else{
		if(uslov(temp, p))
		ink=Dodaj(&(p->desni), temp);
		else
		ink=Dodaj(&(p->levi), temp);
		p->bal+=ink;
		
		if(ink!=0 && p->bal!=0){
			if(p->bal<-1){
				if(p->levi->bal<0){
					p=drotacija(p);
				}
				else{
					p->levi=lrotacija(p->levi);
					p=drotacija(p);
				}
			}
			else if(p->bal>1){
				if(p->desni->bal>0){
					p=lrotacija(p);
				}
				else{
					p->desni=drotacija(p->desni);
					p=lrotacija(p);
				}
			}
			else rezultat=1;
		}
	}
	(*p2)=p;
	return rezultat;
}

void Kreiraj(STRUKTURA **p2){
	int i,n;
	STRUKTURA *temp;
	STRUKTURA *p;
	
	p=(*p2);
	
	scanf("%d", &n);
	n=abs(n);
	
	for(i=0; i<n; i++){
		temp=malloc(sizeof(STRUKTURA));
		scanf("%s", temp->ime);
		scanf("%d", &temp->uzrast);
		scanf("%d", &temp->broj_igracaka);
		
		Dodaj(&p, temp);
	}
	(*p2)=p;
}

void Ispis(STRUKTURA *p){
	if(p!=NULL){
		Ispis(p->desni);
		printf("%s %d %d %d\n", p->ime, p->uzrast, p->broj_igracaka, p->bal);
		Ispis(p->levi);
	}
}

STRUKTURA *Brisanje(STRUKTURA *p, STRUKTURA *NOVO, int provera){
	if(p!=NULL){
		NOVO=Brisanje(p->levi, NOVO, provera);
		NOVO=Brisanje(p->desni, NOVO, provera);
		p->levi=NULL;
		p->desni=NULL;
		if(p->uzrast<=provera*12) Dodaj(&NOVO, p);
	}
	return NOVO;
}

int nivo(STRUKTURA *p, int k, int m){
	int dd=0;
	int dl=0;
	if(p){
		if(p->levi) dl=Dubina(p->levi);
		if(p->desni) dd=Dubina(p->desni);
		
		if((dl==k || dd==k) && p->broj_igracaka==m) 
		printf("%s %d %d %d\n", p->ime, p->uzrast, p->broj_igracaka, p->bal);
		
		if(dl>dd) return ++dl;
			else return ++dd;
	}
	else return 0;
}

main(){
	STRUKTURA *p=NULL;
	int provera, k, m;
	
	Kreiraj(&p);
	Ispis(p);
	scanf("%d", &provera);
	p=Brisanje(p, NULL, provera);
	Ispis(p);
	scanf("%d", &k);
	scanf("%d", &m);
	nivo(p, k, m);
}
