#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct po
{
	char ime[30];
	int uzrast;
	int broj;
	
}pod;

typedef struct st
{
	pod data;
	int balans;
	struct st* levi,*desni;
	
}stablo;

#define novi(cvor) cvor = (stablo*) malloc(sizeof(stablo))

void ispis(stablo* koren,int i);
void nivo(stablo* koren,int i,int k, int m);
int dubina(stablo* cvor);
void desna_rotacija(stablo **koren);
void leva_rotacija(stablo **koren);
void sredi(stablo** koren);
pod nadji(stablo **koren);
int dodaj(stablo** koren,pod data);
stablo* obrisi(stablo* cvor,int mes,int *ind);
stablo* formiraj();

main()
{
	stablo* koren;
	koren = formiraj();
	ispis(koren,1);
	
	int mes,ind;
	scanf("%d",&mes);
	mes = mes*12;
	ind = 1;
	while(ind==1 && koren!=NULL)
	{
		ind = 0;
		koren = obrisi(koren,mes,&ind);
	}
	
	printf("\n*********Posle brisanja********\n");
	ispis(koren,1);
	
	int k,m;
	scanf("%d",&k); //nivo
	scanf("%d",&m); //broj poklona
	
	printf("\n***Nivo k, broj m****\n");
	if(koren != NULL && dubina(koren)>=k)
		nivo(koren,1,k,m);
	else printf("Nema k nivoa.");
	
}


void nivo(stablo* koren,int i,int k, int m)
{
	if(koren)
	{
		nivo(koren->desni,i+1,k,m);
		if(i==k && koren->data.broj ==m)
			printf("\nnivo %d. %s %d\n",i,koren->data.ime,koren->data.uzrast);
		nivo(koren->levi,i+1,k,m);
	}
}

stablo* obrisi(stablo* cvor,int mes,int *ind)
{
	stablo* pom;
	pod data;
	
	if(cvor==NULL) return NULL;
	
	if(cvor->data.uzrast > mes)
	{
		*ind = 1;
		
		if(cvor->levi ==NULL && cvor->desni ==NULL)
		{
			free(cvor);
			return(NULL);
		}
		if(cvor->levi!=NULL && cvor->desni==NULL)
		{
			pom = cvor->levi;
			free(cvor);
			return pom;	
		}
		if(cvor->levi==NULL && cvor->desni !=NULL)
		{
			pom = cvor->desni;
			free(cvor);
			return pom;
			
		}
		if(cvor->levi!=NULL && cvor->desni!=NULL)
		{
			data = nadji(&(cvor->desni));
			cvor->data = data;
			cvor->balans = dubina(cvor->desni) - dubina(cvor->levi);
			sredi(&cvor);
			return cvor;
		}
	}
	else
	{
		cvor->levi = obrisi(cvor->levi,mes,ind);
		cvor->balans = dubina(cvor->desni) - dubina(cvor->levi);
		sredi(&cvor);
		
		cvor->desni = obrisi(cvor->desni,mes,ind);
		cvor->balans = dubina(cvor->desni) - dubina(cvor->levi);
		sredi(&cvor);
		
		return cvor;
	}
}

pod nadji(stablo **koren)
{
	stablo* cvor,*del;
	cvor = *koren;
	pod data;
	
	if(cvor->levi==NULL)
	{
		del = cvor;
		data = cvor->data;
		cvor=cvor->desni;
		free(del);
	}
	else data = nadji(&(cvor->levi));
	
	if(cvor)
	{
		cvor->balans = dubina(cvor->desni) - dubina(cvor->levi);
		sredi(&cvor);
	}
	
	*koren = cvor;
	return data;
}

void sredi(stablo** koren)
{
	stablo* cvor;
	if(*koren)
	{
		cvor = *koren;
		if(cvor->balans < -1)
			if(cvor->levi->balans < 0)
				desna_rotacija(&cvor);
			else
			{
				leva_rotacija(&(cvor->levi));
				desna_rotacija(&cvor);
			}
		if(cvor->balans > 1)
			if(cvor->desni->balans > 0)
				leva_rotacija(&cvor);
			else
			{
				desna_rotacija(&(cvor->desni));
				leva_rotacija(&cvor);
			}
	}
	
	*koren = cvor;
}

int dodaj(stablo** koren,pod data)
{
	int inkrement,rezultat = 0;
	stablo* cvor;
	cvor = *koren;
	
	if(cvor==NULL)
	{
		novi(cvor);
		cvor->data = data;
		cvor->levi = cvor->desni = NULL;
		cvor->balans = 0;
		
		rezultat = 1;
	}
	else
	{
		if(cvor->data.uzrast != data.uzrast)
		{
			if(cvor->data.uzrast < data.uzrast)
				inkrement = dodaj(&(cvor->desni),data);
			else
				inkrement = -dodaj(&(cvor->levi),data);
		}
		else
		{
			if(strcmp(cvor->data.ime,data.ime) < 0 )
				inkrement = -dodaj(&(cvor->levi),data);
			else
				inkrement = dodaj(&(cvor->desni),data);
		}
		
		cvor->balans += inkrement;
		
		if(inkrement!=0 && cvor->balans!=0)
		{
			if(cvor->balans < -1)
				if(cvor->levi->balans < 0)
					desna_rotacija(&cvor);
				else
				{
					leva_rotacija(&(cvor->levi));
					desna_rotacija(&cvor);
				}
			else if(cvor->balans > 1)
				if(cvor->desni->balans > 0)
					leva_rotacija(&cvor);
				else
				{
					desna_rotacija(&(cvor->desni));
					leva_rotacija(&cvor);
				}
			else rezultat = 1;
		}
	}
	
	*koren = cvor;
	return rezultat;
}

void desna_rotacija(stablo** koren)
{
	stablo *pomdesni,*pomlevi;
	pomdesni = *koren;
	pomlevi = pomdesni->levi;
	pomdesni->levi = pomlevi->desni;
	pomlevi->desni = pomdesni;
	*koren = pomlevi;
	
	pomdesni->balans = dubina(pomdesni->desni) - dubina(pomdesni->levi);
	pomlevi->balans = dubina(pomlevi->desni) - dubina(pomlevi->levi);
	
}

void leva_rotacija(stablo **koren)
{
	stablo* pomlevi,*pomdesni;
	pomlevi = *koren;
	pomdesni = pomlevi->desni;
	pomlevi->desni = pomdesni->levi;
	pomdesni->levi = pomlevi;
	*koren = pomdesni;
	
	pomdesni->balans = dubina(pomdesni->desni) - dubina(pomdesni->levi);
	pomlevi->balans = dubina(pomlevi->desni) - dubina(pomlevi->levi);
	 
}

int dubina(stablo* cvor)
{
	int levo, desno;
	levo = desno = 0;
	if(cvor)
	{
		if(cvor->levi) levo = dubina(cvor->levi);
		if(cvor->desni) desno = dubina(cvor->desni);
		if(levo> desno) return ++levo;
		else return ++desno;
		
	}else return 0;
	
}

stablo* formiraj()
{
	stablo* koren;
	koren = NULL;
	int n;
	pod data;
	
	scanf("%d",&n);
	while(n--)
	{
		getchar();
		fgets(data.ime,30,stdin);
		scanf("%d",&(data.uzrast)); //u mesecima
		scanf("%d",&(data.broj)); //broj igracaka
		dodaj(&koren,data);
	}
	
	return koren;
}

void ispis(stablo* koren,int i)
{
	if(koren)
	{
		ispis(koren->desni,i+1);
		printf("nivo %d. %s %d %d\n",i,koren->data.ime,koren->data.uzrast,koren->data.broj);
		ispis(koren->levi,i+1);
	}
	
}

