#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct dete
{
	char ime[30];
	int uzrast;
	int broj;
	int balans;
	struct dete *levi, *desni;
};

#define novi(x) x=(struct dete *)malloc(sizeof(struct dete))

struct dete *form(void);
int dodaj(struct dete **p, char *ime, int uzrast, int broj);
void lrotacija(struct dete **p);
void drotacija(struct dete **p);
int dubina(struct dete *p);
void ispis_najveci(struct dete *p);
void kreiraj(struct dete **new, struct dete *p, int x);
void prebroji(struct dete *p, int k, int m, int nivo);

int main(void)
{
	struct dete *p=NULL, *new=NULL;
	int x;
	p=form();
	printf("\n-------------------\n");
	ispis_najveci(p);
	printf("Unesite broj godina (x): ");
	scanf("%d",&x);
	kreiraj(&new,p,x);
	printf("\n-------------------\n");
	ispis_najveci(new);
	int k,m;
	printf("Unesite nivo: ");
	scanf("%d",&k);
	printf("Unesite broj poklona: ");
	scanf("%d",&m);
	int nivo=0;
	printf("\n-------------------\n");
	prebroji(new,k,m,nivo);
	return 0;
}

struct dete *form(void)
{
	struct dete *glava=NULL;
	char ime[30];
	int uzrast, broj;
	int n, i;
	scanf("%d",&n);
	getchar();
	for (i=0; i<n; i++)
	{
		scanf("%s",ime);
		scanf("%d",&uzrast);
		scanf("%d",&broj);
		getchar();
		dodaj(&glava,ime,uzrast,broj);
	}
	return glava;
}

int dubina(struct dete *p)
{
	int dl=0, dd=0;
	if (p)
	{
		if (p->levi)
			dl=dubina(p->levi);
		if (p->desni)
			dd=dubina(p->desni);
		if (dl>dd)
			++dl;
		else
			++dd;
	
	}
	else
		return 0;
}

void lrotacija(struct dete **p)
{
	struct dete *poml, *pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->desni);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->desni);
}
void drotacija(struct dete **p)
{
	struct dete *poml, *pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->desni);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->desni);
}

int dodaj(struct dete **p, char *ime, int uzrast, int broj)
{
	int rezultat=0, inkrement;
	struct dete *t;
	t=*p;
	if (!t)
	{
		novi(t);
		t->uzrast=uzrast;
		t->broj=broj;
		strcpy(t->ime,ime);
		t->levi=t->desni=NULL;
		t->balans=0;
		rezultat=1;
	}
	else
	{
		if (t->uzrast<uzrast)
			inkrement=-dodaj(&(t->levi),ime,uzrast,broj);
		else if (t->uzrast>uzrast)
			inkrement=dodaj(&(t->desni),ime,uzrast,broj);
		else
		{
			if (strcmp(t->ime,ime)<0)
				inkrement=-dodaj(&(t->levi),ime,uzrast,broj);
			else
				inkrement=dodaj(&(t->desni),ime,uzrast,broj);
		}
		t->balans+=inkrement;
		if (inkrement!=0 && t->balans!=0)
		{
			if (t->balans<-1)
			{
				if (t->levi->balans<0)
					drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if (t->balans>1)
			{
				if (t->desni->balans>0)
					lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else
				rezultat=1;
		}
	}
	*p=t;
	return rezultat;
}

void ispis_najveci(struct dete *p)
{
	if (p)
	{
		if (p->desni)
			ispis_najveci(p->desni);
		printf("Ime: %s Uzrast: %d Broj: %d\n",p->ime,p->uzrast,p->broj);
		if (p->levi)
			ispis_najveci(p->levi);
	}
}

void kreiraj(struct dete **new, struct dete *p, int x)
{
	if (p)
	{
		if (p->desni)
			kreiraj(new,p->desni,x);
		if (p->uzrast+12<x*12) // ako je uzrast broj meseci za ovu godinu onda +12 za sledecu i x kao godine pretvorim u broj meseci
			dodaj(new,p->ime,p->uzrast,p->broj);
		if (p->levi)
			kreiraj(new,p->levi,x);
	}
}

void prebroji(struct dete *p, int k, int m, int nivo)
{
	if (p)
	{
		nivo++;
		if (k==nivo && m==p->broj)
			printf("Ime: %s Uzrast: %d Broj poklona: %d\n",p->ime,p->uzrast,p->broj);
		if (p->levi)
			prebroji(p->levi,k,m,nivo);
			
		if (p->desni)
			prebroji(p->desni,k,m,nivo);
	}
}
